#property copyright "Copyright  2006"
#property link      "www.indonesia-investors.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 RoyalBlue
#property indicator_color2 Red
#property indicator_color3 RoyalBlue
#property indicator_color4 Red
#property indicator_color5 RoyalBlue
#property indicator_color6 Red

extern int Length = 20;
extern int Deviation = 2;
extern double MoneyRisk = 1.0;
extern int Signal = 1;
extern int Line = 1;
extern int Nbars = 1000;
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];
double g_ibuf_120[];
double g_ibuf_124[];
extern bool SoundON = TRUE;
bool gi_132 = FALSE;
bool gi_136 = FALSE;

int init() {
   SetIndexBuffer(0, g_ibuf_104);
   SetIndexBuffer(1, g_ibuf_108);
   SetIndexBuffer(2, g_ibuf_112);
   SetIndexBuffer(3, g_ibuf_116);
   SetIndexBuffer(4, g_ibuf_120);
   SetIndexBuffer(5, g_ibuf_124);
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID, 1);
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID, 1);
   SetIndexStyle(2, DRAW_ARROW, STYLE_SOLID, 1);
   SetIndexStyle(3, DRAW_ARROW, STYLE_SOLID, 1);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexArrow(0, 159);
   SetIndexArrow(1, 159);
   SetIndexArrow(2, 108);
   SetIndexArrow(3, 108);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   string ls_0 = "BBands Stop(" + Length + "," + Deviation + ")";
   IndicatorShortName(ls_0);
   SetIndexLabel(0, "UpTrend Stop");
   SetIndexLabel(1, "DownTrend Stop");
   SetIndexLabel(2, "UpTrend Signal");
   SetIndexLabel(3, "DownTrend Signal");
   SetIndexLabel(4, "UpTrend Line");
   SetIndexLabel(5, "DownTrend Line");
   SetIndexDrawBegin(0, Length);
   SetIndexDrawBegin(1, Length);
   SetIndexDrawBegin(2, Length);
   SetIndexDrawBegin(3, Length);
   SetIndexDrawBegin(4, Length);
   SetIndexDrawBegin(5, Length);
   return (0);
}

int start() {
   double ld_4;
   int li_20;
   double lda_24[25000];
   double lda_28[25000];
   double lda_32[25000];
   double lda_36[25000];
   /*int l_str2time_0 = StrToTime(DoubleToStr(2010, 0) + "." + DoubleToStr(12, 0) + "." + DoubleToStr(30, 0));
   if (TimeCurrent() >= l_str2time_0) {
      Comment("indicator expired contact indonesia-investors.com");
      ld_4 = 1 / ld_4;
   }
   if (TimeCurrent() >= l_str2time_0) return (0);*/
   for (int l_shift_16 = Nbars; l_shift_16 >= 0; l_shift_16--) {
      g_ibuf_104[l_shift_16] = 0;
      g_ibuf_108[l_shift_16] = 0;
      g_ibuf_112[l_shift_16] = 0;
      g_ibuf_116[l_shift_16] = 0;
      g_ibuf_120[l_shift_16] = EMPTY_VALUE;
      g_ibuf_124[l_shift_16] = EMPTY_VALUE;
   }
   for (l_shift_16 = Nbars - Length - 1; l_shift_16 >= 0; l_shift_16--) {
      lda_24[l_shift_16] = iBands(NULL, 0, Length, Deviation, 0, PRICE_CLOSE, MODE_UPPER, l_shift_16);
      lda_28[l_shift_16] = iBands(NULL, 0, Length, Deviation, 0, PRICE_CLOSE, MODE_LOWER, l_shift_16);
      if (Close[l_shift_16] > lda_24[l_shift_16 + 1]) li_20 = 1;
      if (Close[l_shift_16] < lda_28[l_shift_16 + 1]) li_20 = -1;
      if (li_20 > 0 && lda_28[l_shift_16] < lda_28[l_shift_16 + 1]) lda_28[l_shift_16] = lda_28[l_shift_16 + 1];
      if (li_20 < 0 && lda_24[l_shift_16] > lda_24[l_shift_16 + 1]) lda_24[l_shift_16] = lda_24[l_shift_16 + 1];
      lda_32[l_shift_16] = lda_24[l_shift_16] + (MoneyRisk - 1.0) / 2.0 * (lda_24[l_shift_16] - lda_28[l_shift_16]);
      lda_36[l_shift_16] = lda_28[l_shift_16] - (MoneyRisk - 1.0) / 2.0 * (lda_24[l_shift_16] - lda_28[l_shift_16]);
      if (li_20 > 0 && lda_36[l_shift_16] < lda_36[l_shift_16 + 1]) lda_36[l_shift_16] = lda_36[l_shift_16 + 1];
      if (li_20 < 0 && lda_32[l_shift_16] > lda_32[l_shift_16 + 1]) lda_32[l_shift_16] = lda_32[l_shift_16 + 1];
      if (li_20 > 0) {
         if (Signal > 0 && g_ibuf_104[l_shift_16 + 1] == -1.0) {
            g_ibuf_112[l_shift_16] = lda_36[l_shift_16];
            g_ibuf_104[l_shift_16] = lda_36[l_shift_16];
            if (Line > 0) g_ibuf_120[l_shift_16] = lda_36[l_shift_16];
            if (SoundON == TRUE && l_shift_16 == 0 && !gi_132) {
               Alert("BBands going Up on ", Symbol(), "-", Period());
               gi_132 = TRUE;
               gi_136 = FALSE;
            }
         } else {
            g_ibuf_104[l_shift_16] = lda_36[l_shift_16];
            if (Line > 0) g_ibuf_120[l_shift_16] = lda_36[l_shift_16];
            g_ibuf_112[l_shift_16] = -1;
         }
         if (Signal == 2) g_ibuf_104[l_shift_16] = 0;
         g_ibuf_116[l_shift_16] = -1;
         g_ibuf_108[l_shift_16] = -1.0;
         g_ibuf_124[l_shift_16] = EMPTY_VALUE;
      }
      if (li_20 < 0) {
         if (Signal > 0 && g_ibuf_108[l_shift_16 + 1] == -1.0) {
            g_ibuf_116[l_shift_16] = lda_32[l_shift_16];
            g_ibuf_108[l_shift_16] = lda_32[l_shift_16];
            if (Line > 0) g_ibuf_124[l_shift_16] = lda_32[l_shift_16];
            if (SoundON == TRUE && l_shift_16 == 0 && !gi_136) {
               Alert("BBands going Down on ", Symbol(), "-", Period());
               gi_136 = TRUE;
               gi_132 = FALSE;
            }
         } else {
            g_ibuf_108[l_shift_16] = lda_32[l_shift_16];
            if (Line > 0) g_ibuf_124[l_shift_16] = lda_32[l_shift_16];
            g_ibuf_116[l_shift_16] = -1;
         }
         if (Signal == 2) g_ibuf_108[l_shift_16] = 0;
         g_ibuf_112[l_shift_16] = -1;
         g_ibuf_104[l_shift_16] = -1.0;
         g_ibuf_120[l_shift_16] = EMPTY_VALUE;
      }
   }
   return (0);
}