#property copyright "Copyright  2006"
#property link      "www.indonesia-investors.com"

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Sienna
#property indicator_color4 Blue

extern int Sensetive = 150;
extern int DeadZonePip = 30;
extern int ExplosionPower = 15;
extern int TrendPower = 15;
extern bool AlertWindow = TRUE;
extern int AlertCount = 500;
extern bool AlertLong = TRUE;
extern bool AlertShort = TRUE;
extern bool AlertExitLong = TRUE;
extern bool AlertExitShort = TRUE;
double g_ibuf_116[];
double g_ibuf_120[];
double g_ibuf_124[];
double g_ibuf_128[];
int gi_132 = 1;
int gi_136 = 1;
int gi_140 = 1;
int gi_144 = 1;
int gi_148 = 0;
int gi_152 = -1;
double g_ask_156;
double g_bid_164;

int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexStyle(3, DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(0, g_ibuf_116);
   SetIndexBuffer(1, g_ibuf_120);
   SetIndexBuffer(2, g_ibuf_124);
   SetIndexBuffer(3, g_ibuf_128);
   IndicatorShortName("Ind Int: [S(" + Sensetive + ") - DZ(" + DeadZonePip + ") - EP(" + ExplosionPower + ") - TP(" + TrendPower + ")]");
   Comment("2008");
   return (0);
}

int start() {
   double ld_4;
   double ld_12;
   double ld_20;
   double ld_28;
   double ld_36;
   double ld_44;
   double ld_52;
   double ld_60;
   /*int l_str2time_0 = StrToTime(DoubleToStr(2010, 0) + "." + DoubleToStr(12, 0) + "." + DoubleToStr(30, 0));
   if (TimeCurrent() >= l_str2time_0) {
      Comment("indicator expired contact indonesia-investors.com");
      ld_4 = 1 / ld_4;
   }
   if (TimeCurrent() >= l_str2time_0) return (0);*/
   int li_76 = IndicatorCounted();
   if (li_76 < 0) return (-1);
   if (li_76 > 0) li_76--;
   int li_68 = Bars - li_76;
   for (int l_shift_72 = li_68 - 1; l_shift_72 >= 0; l_shift_72--) {
      ld_12 = (iMACD(NULL, 0, 20, 40, 9, PRICE_CLOSE, MODE_MAIN, l_shift_72) - iMACD(NULL, 0, 20, 40, 9, PRICE_CLOSE, MODE_MAIN, l_shift_72 + 1)) * Sensetive;
      ld_20 = (iMACD(NULL, 0, 20, 40, 9, PRICE_CLOSE, MODE_MAIN, l_shift_72 + 2) - iMACD(NULL, 0, 20, 40, 9, PRICE_CLOSE, MODE_MAIN, l_shift_72 + 3)) * Sensetive;
      ld_28 = iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_UPPER, l_shift_72) - iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_LOWER, l_shift_72);
      ld_36 = iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_UPPER, l_shift_72 + 1) - iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_LOWER, l_shift_72 + 1);
      ld_44 = Point * DeadZonePip;
      g_ibuf_116[l_shift_72] = 0;
      g_ibuf_120[l_shift_72] = 0;
      g_ibuf_124[l_shift_72] = 0;
      g_ibuf_128[l_shift_72] = 0;
      if (ld_12 >= 0.0) g_ibuf_116[l_shift_72] = ld_12;
      if (ld_12 < 0.0) g_ibuf_120[l_shift_72] = -1.0 * ld_12;
      g_ibuf_124[l_shift_72] = ld_28;
      g_ibuf_128[l_shift_72] = ld_44;
      if (l_shift_72 == 0) {
         if (ld_12 > 0.0 && ld_12 > ld_28 && ld_12 > ld_44 && ld_28 > ld_44 && ld_28 > ld_36 && ld_12 > ld_20 && gi_132 < AlertCount && AlertLong == TRUE && Ask != g_ask_156) {
            ld_52 = 100.0 * (ld_12 - ld_20) / ld_12;
            ld_60 = 100.0 * (ld_28 - ld_36) / ld_28;
            g_ask_156 = Ask;
            if (ld_60 >= ExplosionPower && ld_52 >= TrendPower) {
               if (AlertWindow == TRUE) Alert(gi_132, "- ", Symbol(), " - BUY ", " (", DoubleToStr(g_ask_156, Digits), ") Trend PWR ", DoubleToStr(ld_52, 0), " - Exp PWR ", DoubleToStr(ld_60, 0));
               else Print(gi_132, "- ", Symbol(), " - BUY ", " (", DoubleToStr(g_ask_156, Digits), ") Trend PWR ", DoubleToStr(ld_52, 0), " - Exp PWR ", DoubleToStr(ld_60, 0));
               gi_132++;
            }
            gi_148 = 1;
         }
         if (ld_12 < 0.0 && MathAbs(ld_12) > ld_28 && MathAbs(ld_12) > ld_44 && ld_28 > ld_44 && ld_28 > ld_36 && MathAbs(ld_12) > MathAbs(ld_20) && gi_136 < AlertCount && AlertShort == TRUE &&
            Bid != g_bid_164) {
            ld_52 = 100.0 * (MathAbs(ld_12) - MathAbs(ld_20)) / MathAbs(ld_12);
            ld_60 = 100.0 * (ld_28 - ld_36) / ld_28;
            g_bid_164 = Bid;
            if (ld_60 >= ExplosionPower && ld_52 >= TrendPower) {
               if (AlertWindow == TRUE) Alert(gi_136, "- ", Symbol(), " - SELL ", " (", DoubleToStr(g_bid_164, Digits), ") Trend PWR ", DoubleToStr(ld_52, 0), " - Exp PWR ", DoubleToStr(ld_60, 0));
               else Print(gi_136, "- ", Symbol(), " - SELL ", " (", DoubleToStr(g_bid_164, Digits), ") Trend PWR ", DoubleToStr(ld_52, 0), " - Exp PWR ", DoubleToStr(ld_60, 0));
               gi_136++;
            }
            gi_148 = 2;
         }
         if (ld_12 > 0.0 && ld_12 < ld_28 && ld_12 < ld_20 && ld_20 > ld_36 && ld_12 > ld_44 && ld_28 > ld_44 && gi_140 <= AlertCount && AlertExitLong == TRUE && Bid != g_bid_164) {
            g_bid_164 = Bid;
            if (AlertWindow == TRUE) Alert(gi_140, "- ", Symbol(), " - Exit BUY ", " ", DoubleToStr(g_bid_164, Digits));
            else Print(gi_140, "- ", Symbol(), " - Exit BUY ", " ", DoubleToStr(g_bid_164, Digits));
            gi_148 = 3;
            gi_140++;
         }
         if (ld_12 < 0.0 && MathAbs(ld_12) < ld_28 && MathAbs(ld_12) < MathAbs(ld_20) && MathAbs(ld_20) > ld_36 && ld_12 > ld_44 && ld_28 > ld_44 && gi_144 <= AlertCount &&
            AlertExitShort == TRUE && Ask != g_ask_156) {
            g_ask_156 = Ask;
            if (AlertWindow == TRUE) Alert(gi_144, "- ", Symbol(), " - Exit SELL ", " ", DoubleToStr(g_ask_156, Digits));
            else Print(gi_144, "- ", Symbol(), " - Exit SELL ", " ", DoubleToStr(g_ask_156, Digits));
            gi_148 = 4;
            gi_144++;
         }
         gi_152 = gi_148;
      }
      if (gi_148 != gi_152) {
         gi_132 = 1;
         gi_136 = 1;
         gi_140 = 1;
         gi_144 = 1;
      }
   }
   return (0);
}